<template>
	<div id="app">
		<div class="container row">
			<img alt="NYT Logo" id="nyt_logo" src="https://upload.wikimedia.org/wikipedia/commons/7/77/The_New_York_Times_logo.png">
			<div v-if="articles.length > 0">
				<div  
					v-for="article in articles" v-bind:key="article.url">
					<Article :article="article"></Article>
				</div>
			</div>
			<div v-else>
				<p> No Articles have been found. </p>
			</div>

		</div>
		
			
	</div>
</template>

<script>

import Article from "./components/Article.vue"
import Axios from 'axios'
import M from "materialize-css"

async function GetJson(){
	try{
		var json = await Axios.get("https://api.nytimes.com/svc/topstories/v2/world.json?api-key=vdKDkooYgHPHHURHYxmvBKVJ4bWI3KIi");
		console.info(json);
		return json;
	}
	catch{
		return JSON.parse({data:{status:"Failed"}})
	}
}
async function UpdateArticles(){
	var json = await GetJson();
	if(json.data.status != 'OK'){
		console.warn("API responsed with a status != OK", json);
		return;
	}
	var resultsLightweight = [];
	for(let entry of json.data.results){
		console.log(entry);
		entry = JSON.parse(JSON.stringify(entry));
		var image = GetImage(entry.multimedia);
		resultsLightweight = [...resultsLightweight, {section: entry.section, title: entry.title, abstract: entry.abstract, url: entry.short_url, image: image}]
	}
	console.info(resultsLightweight);
	return resultsLightweight;
}


function GetImage(media){
	if(media == null || media.count == 0){
		return {path: "https://heise.cloudimg.io/width/610/q85.png-lossy-85.webp-lossy-85.foil1/_www-heise-de_/imgs/18/2/3/5/1/8/7/1/vue-737953b5daad7f01.jpeg"};
	}

	return {path: media[0].url, caption: media[0].caption}
}

export default {
	name: 'App',
	components: {
		Article
	},
	mounted: function(){
		M.AutoInit();
		UpdateArticles().then(articles => {
			this.articles = articles;
		})
	},
	data: function(){
		return {
			articles: [],
		}
	}
}
</script>

<style lang="sass">
#app
	font-family: Avenir, Helvetica, Arial, sans-serif
	-webkit-font-smoothing: antialiased
	-moz-osx-font-smoothing: grayscale
	text-align: center
	color: #2c3e50
	margin-top: 60px
	img#nyt_logo
		max-width: 500px


</style>
